'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _get = function get(object, property, receiver) { var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _React = require('react/addons');

var _React2 = _interopRequireWildcard(_React);

var _assign = require('object-assign');

var _assign2 = _interopRequireWildcard(_assign);

var Component = _React2['default'].Component;
var cloneWithProps = _React2['default'].addons.cloneWithProps;

var PlayStore = (function () {
    function PlayStore() {
        _classCallCheck(this, PlayStore);

        this._audios = [];
    }

    _createClass(PlayStore, [{
        key: 'add',
        value: function add(soundCloudAudio) {
            var isPresent = false;
            var audios = this._audios;
            var len = audios.length;

            for (var i = 0; i < len; i++) {
                var _soundCloudAudio = audios[i];
                if (_soundCloudAudio.playing === soundCloudAudio.playing) {
                    isPresent = true;
                    break;
                }
            }
            if (!isPresent) {
                this._audios.push(soundCloudAudio);
            }
        }
    }, {
        key: 'stopAll',
        value: function stopAll(playing) {
            this._audios.forEach(function (soundCloudAudio) {
                if (soundCloudAudio.playing && soundCloudAudio.playing !== playing) {
                    soundCloudAudio.stop();
                }
            });
        }
    }]);

    return PlayStore;
})();

var MultiplePlayerContainer = (function (_Component) {
    function MultiplePlayerContainer() {
        _classCallCheck(this, MultiplePlayerContainer);

        _get(Object.getPrototypeOf(MultiplePlayerContainer.prototype), 'constructor', this).call(this);

        // handling multiple audio instances on the page
        this.playStore = new PlayStore();

        this.wrapChild = this.wrapChild.bind(this);
        this.handleStartPlay = this.handleStartPlay.bind(this);
    }

    _inherits(MultiplePlayerContainer, _Component);

    _createClass(MultiplePlayerContainer, [{
        key: 'handleStartPlay',
        value: function handleStartPlay(soundCloudAudio, playing) {
            this.playStore.stopAll(playing);
            this.playStore.add(soundCloudAudio);
        }
    }, {
        key: 'wrapChild',
        value: function wrapChild(child) {
            var newProps = _assign2['default']({}, {
                onStartTrack: this.handleStartPlay
            }, this.state);
            return cloneWithProps(child, newProps);
        }
    }, {
        key: 'render',
        value: function render() {
            var children = this.props.children;

            return _React2['default'].createElement(
                'span',
                null,
                _React2['default'].Children.map(children, this.wrapChild)
            );
        }
    }]);

    return MultiplePlayerContainer;
})(Component);

exports['default'] = MultiplePlayerContainer;
module.exports = exports['default'];